package com.dbs.drnd.ark.cdc.http.inter;

import org.apache.http.HttpEntity;
import org.apache.http.client.methods.HttpDelete;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.client.methods.HttpPut;
import org.apache.http.client.methods.HttpUriRequest;
import org.apache.http.entity.ContentType;
import org.apache.http.entity.StringEntity;

public class ArkApi {

    private static ContentType contentType = ContentType.create("application/json", "UTF-8");
    private final String uri;
    private final Method method;

    public ArkApi(String url, Method method) {
        this.uri = url;
        this.method = method;
    }

    public HttpUriRequest getRequest() {
        return getRequest("");
    }

    public HttpUriRequest getRequest(String param) {

        switch (this.method) {
            case GET: {
                return new HttpGet(uri + param);
            }
            case POST: {
                HttpPost post = new HttpPost(uri);
                post.setEntity(getEntity(param));
                return post;
            }
            case PUT: {
                HttpPut put = new HttpPut(uri);
                put.setEntity(getEntity(param));
                return put;
            }
            case DELETE: {
                return new HttpDelete(uri + param);
            }
        }

        return null;
    }

    private HttpEntity getEntity(String json) {
        return new StringEntity(json, ArkApi.contentType);
    }
}
